using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace Twitter
{
    public partial class Form1 : Form
    {
# region System Events

        public Form1()
        {
            InitializeComponent();
        }

        private void btnSubmit_Click(object sender, EventArgs e)
        {
            if (txtUser.Text.Trim() != "" && txtPass.Text.Trim() != "")
            {
                if (txtText.Text.Trim() != "" || txtUrl.Text != "")
                {
                    string result;
                    result = PostTweet(txtUser.Text, txtPass.Text, txtText.Text, txtUrl.Text);
                    MessageBox.Show(result);
                    if (result == "Success")
                    {
                        txtText.Text = "";
                        txtUrl.Text = "";
                        lblCount.Text = "0";
                    }
                }
                else
                {
                    MessageBox.Show("Enter Text or URL");
                }
            }
            else
            {
                MessageBox.Show("Enter Username and password of your twitter account\n It will not be stored anywhere");
            }
        }        

        private void Form1_Resize(object sender, EventArgs e)
        {
            if (FormWindowState.Minimized == WindowState)
                Hide();
        }

        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }
        
        private void txtText_TextChanged(object sender, EventArgs e)
        {
            lblCount.Text = txtText.Text.Trim().Length.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Point pnt=new Point(0,28);
            panTiny.Location = pnt;
            panTiny.Hide();
            Size sz=new Size(540,195);
            this.Size = sz;
            notifyIcon1.ContextMenuStrip = contextMenuStrip1;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            txtOriginalUrl.Text = checkHttp(txtOriginalUrl.Text.Trim());
            if (checkUrl(txtOriginalUrl.Text))
            {
                txtResultUrl.Text = getTinyUrl(txtOriginalUrl.Text);
            }
            else
            {
                txtResultUrl.Text = "Invalid Url";
            }
        }

        private void exitToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void twitItToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
            showTwit();

        }

        private void getTinyURLToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
            showTiny();
        }

        private void lnkTwit_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            showTwit();
        }

        private void lnkTiny_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            showTiny();
        }

        private void lnkAbout_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            MessageBox.Show("Will create a tiny Url of the url you provided (If there is any),\n and will post to Twitter using the password and username you provided\n It will not store your Username or password anywhere");
        }

# endregion


#region Functions

        private static string PostTweet(string username, string password, string tweet, string ur)
        {
            try
            {
                ur = checkHttp(ur);
                string user = Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(username + ":" + password));
                if (ur.Trim() != "")
                {
                    if (checkUrl(ur))
                    {
                        ur = getTinyUrl(ur);
                    }
                    else
                    {
                       return ("Invalid URL");
                    }
                }
                byte[] bytes = System.Text.Encoding.ASCII.GetBytes("status=" + tweet + " " + ur);
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://twitter.com/statuses/update.xml");
                request.Method = "POST";
                request.ServicePoint.Expect100Continue = false;
                request.Headers.Add("Authorization", "Basic " + user);
                request.ContentType = "application/x-www-form-urlencoded";
                request.ContentLength = bytes.Length;
                Stream reqStream = request.GetRequestStream();
                reqStream.Write(bytes, 0, bytes.Length);
                reqStream.Close();
                return ("Success");
            }
            catch (Exception ex)
            {
                return (ex.Message);
            }
        }

        private static string getTinyUrl(string ur)
        {
            System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
            if (!cmpUrl.IsPrefix(ur, "http://tinyurl.com"))
            {
                string address = "http://tinyurl.com/api-create.php?url=" + ur;
                System.Net.WebClient client = new System.Net.WebClient();
                return (client.DownloadString(address));
            }
            else
            {
                return (ur);
            }
        }

        private static bool checkUrl(string url)
        {
            if (url.Trim() != "")
            {
                Regex RgxUrl = new Regex("http(s)?://([\\w-]+\\.)+[\\w-]+(/[\\w- ./?%&=]*)?");
                if (RgxUrl.IsMatch(url))
                {
                    return (true);
                }
                else
                {
                    return (false);
                }
            }
            else
            {
                return(false);
            }
        }

        private static string checkHttp(string url)
        {
            System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
            if (cmpUrl.IsPrefix(url, "http://") == false && cmpUrl.IsPrefix(url, "https://") == false && url.Trim()!="")
            {
                url = "http://" + url;
            }
            return (url);
        }

        private void showTiny()
        {
            panTiny.Show();
            panTwit.Hide();
        }

        private void showTwit()
        {
            panTwit.Show();
            panTiny.Hide();
        }

#endregion

    }
}